// inspect taken from node.js
// lib/util.js
// shims by yours truly

(function() {
var module = { exports: {} }
  , exports = module.exports;

if (!window.console) window.console = {};
if (!console.log) console.log = function() {
  window.alert(Array.prototype.slice.call(arguments).join(' '));
};
if (!console.error) console.error = console.log;

Object.keys = 
Object.keys || function f(o) {
  var k, c = [];
  if (o) for (k in o) if (f.hasOwnProperty.call(o, k)) c.push(k);
  return c;
};
Object.getOwnPropertyNames = 
Object.getOwnPropertyNames || Object.keys;

/*if (!('__proto__' in {})) Object.prototype.__proto__ = {};
Object.prototype.__lookupGetter__ = 
Object.prototype.__lookupGetter__ || function() {};
Object.prototype.__lookupSetter__ = 
Object.prototype.__lookupSetter__ || function() {};*/

Date.prototype.toUTCString = 
Date.prototype.toUTCString || Date.prototype.toGMTString;

Array.isArray = 
Array.isArray || function(obj) { 
  return Object.prototype.toString.call(obj) === '[object Array]'; 
};
Array.prototype.map = 
Array.prototype.map || function(func, con) {
  for (var o = [], i = 0, l = this.length; i < l; i++) {
    o.push(func.call(con, this[i], i, this));
  }
  return o;
};
Array.prototype.indexOf = 
Array.prototype.indexOf || function(obj) {
  var i = 0, l = this.length;
  for (; i < l; i++) if (this[i] === obj) return i;
  return -1;
};
Array.prototype.reduce = 
Array.prototype.reduce || function f(func) {
  var i = 0
    , l = this.length
    , cur = arguments.length <= 1 ? this[i++] : arguments[1];

  for (; i < l; i++) {
    if (f.hasOwnProperty.call(this, i)) {
      cur = func(cur, this[i], i, this);
    }
  }
  return cur;
};

window.JSON = 
window.JSON || (function() {
  var lead = function(n) {
    return n < 10 ? '0' + '' + n : n;
  };
  var bad = /[^,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]/
    , strings = /"(\\.|[^"\\])*"/g;
  return {
    toString: function() {
      return '[object JSON]';
    },
    parse: function(str) {
      if (bad.test(str.replace(strings, ''))) {
        throw new
          SyntaxError('Parse error.');
      }
      try {
        str = 'return (' + str + ');';
        return new Function('', str).call(null);
      } catch(e) {
        throw new
          SyntaxError('Parse error.');
      }
    },
    stringify: function stringify(obj) {
      var type = typeof obj
        , out = []
        , val;

      if (type === 'object') {
        // null
        if (!obj) return 'null';

        // array
        if (toString.call(obj) === '[object Array]') {
          for (var i = 0, l = obj.length; i < l; i++) {
            val = stringify(obj[i]);
            if (val) out.push(val);
          }
          return '[' + out.join(',') + ']';
        }

        // regexp
        if ('ignoreCase' in obj) return;

        // date
        if (obj.getUTCFullYear) {
          if (isNaN(obj) || obj.toString() === 'Invalid Date') {
            return stringify(null);
          }
          return stringify(
            obj.getUTCFullYear()
            + '-' + lead(obj.getUTCMonth() + 1)
            + '-' + lead(obj.getUTCDate())
            + 'T' + lead(obj.getUTCHours())
            + ':' + lead(obj.getUTCMinutes())
            + ':' + lead(obj.getUTCSeconds())
            + '.' + obj.getUTCMilliseconds()
            + 'Z'
          );
        }

        // "regular" object
        for (var k in obj) {
          if (hasOwnProperty.call(obj, k)) {
            val = stringify(obj[k]);
            if (val) out.push('"' + k + '":' + val);
          }
        }

        return '{' + out.join(',') + '}';
      } else if (type === 'number') {
        // NaN or Infinity
        if (!isFinite(obj)) return stringify(null);
        // number
        return obj + '';
      } else if (type === 'string') {
        // string
        obj = obj
          .replace(/(\\|")/g, '\\$1')
          .replace(/\r/g, '\\r')
          .replace(/\n/g, '\\n')
          .replace(/\t/g, '\\t')
          .replace(/[\u0000-\u0019\u007e-\uffff]/g, function(s) {
            s = s.charCodeAt(0).toString(16);
            while (s.length < 4) s = '0' + '' + s;
            return '\\u' + s;
          });
        return '"' + obj + '"';
      } else if (type === 'boolean') {
        // bool
        return obj ? 'true' : 'false';
      }
      // functions and undefined return undefined
    }
  };
})();

window.inspect = function(obj, showHidden, depth, colors) {
  var seen = [];

  var stylize = function(str, styleType) {
    return str;
  };
  if (!colors) {
    stylize = function(str, styleType) { return str; };
  }

  function format(value, recurseTimes) {
    // Provide a hook for user-specified inspect functions.
    // Check that value is an object with an inspect function on it
    if (value && typeof value.inspect === 'function' &&
        // Filter out the util module, it's inspect function is special
        value !== exports &&
        // Also filter out any prototype objects using the circular check.
        !(value.constructor && value.constructor.prototype === value)) {
      return value.inspect(recurseTimes);
    }

    // Primitive types cannot have properties
    switch (typeof value) {
      case 'undefined':
        return stylize('undefined', 'undefined');

      case 'string':
        var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
                                                 .replace(/'/g, "\\'")
                                                 .replace(/\\"/g, '"') + '\'';
        return stylize(simple, 'string');

      case 'number':
        return stylize('' + value, 'number');

      case 'boolean':
        return stylize('' + value, 'boolean');
    }
    // For some reason typeof null is "object", so special case here.
    if (value === null) {
      return stylize('null', 'null');
    }

    // Look up the keys of the object.
    var visible_keys = Object.keys(value);
    var keys = showHidden ? Object.getOwnPropertyNames(value) : visible_keys;

    // Functions without properties can be shortcutted.
    if (typeof value === 'function' && keys.length === 0) {
      if (isRegExp(value)) {
        return stylize('' + value, 'regexp');
      } else {
        var name = value.name ? ': ' + value.name : '';
        return stylize('[Function' + name + ']', 'special');
      }
    }

    // Dates without properties can be shortcutted
    if (isDate(value) && keys.length === 0) {
      return stylize(value.toUTCString(), 'date');
    }

    var base, type, braces;
    // Determine the object type
    if (isArray(value)) {
      type = 'Array';
      braces = ['[', ']'];
    } else {
      type = 'Object';
      braces = ['{', '}'];
    }

    // Make functions say that they are functions
    if (typeof value === 'function') {
      var n = value.name ? ': ' + value.name : '';
      base = (isRegExp(value)) ? ' ' + value : ' [Function' + n + ']';
    } else {
      base = '';
    }

    // Make dates with properties first say the date
    if (isDate(value)) {
      base = ' ' + value.toUTCString();
    }

    if (keys.length === 0) {
      return braces[0] + base + braces[1];
    }

    if (recurseTimes < 0) {
      if (isRegExp(value)) {
        return stylize('' + value, 'regexp');
      } else {
        return stylize('[Object]', 'special');
      }
    }

    seen.push(value);

    var output = keys.map(function(key) {
      var name, str;
      if (value.__lookupGetter__) {
        if (value.__lookupGetter__(key)) {
          if (value.__lookupSetter__(key)) {
            str = stylize('[Getter/Setter]', 'special');
          } else {
            str = stylize('[Getter]', 'special');
          }
        } else {
          if (value.__lookupSetter__(key)) {
            str = stylize('[Setter]', 'special');
          }
        }
      }
      if (visible_keys.indexOf(key) < 0) {
        name = '[' + key + ']';
      }
      if (!str) {
        // hack to fix IE
        var good = true;
        try { value[key]; } catch(e) { e = null; good = false; }
        if (good && seen.indexOf(value[key]) < 0) {
          if (recurseTimes === null) {
            str = format(value[key]);
          } else {
            str = format(value[key], recurseTimes - 1);
          }
          if (str.indexOf('\n') > -1) {
            if (isArray(value)) {
              str = str.split('\n').map(function(line) {
                return '  ' + line;
              }).join('\n').substr(2);
            } else {
              str = '\n' + str.split('\n').map(function(line) {
                return '   ' + line;
              }).join('\n');
            }
          }
        } else {
          str = stylize('[Circular]', 'special');
        }
      }
      if (typeof name === 'undefined') {
        if (type === 'Array' && key.match(/^\d+$/)) {
          return str;
        }
        name = JSON.stringify('' + key);
        if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
          name = name.substr(1, name.length - 2);
          name = stylize(name, 'name');
        } else {
          name = name.replace(/'/g, "\\'")
                     .replace(/\\"/g, '"')
                     .replace(/(^"|"$)/g, "'");
          name = stylize(name, 'string');
        }
      }

      return name + ': ' + str;
    });

    seen.pop();

    var numLinesEst = 0;
    var length = output.reduce(function(prev, cur) {
      numLinesEst++;
      if (cur.indexOf('\n') >= 0) numLinesEst++;
      return prev + cur.length + 1;
    }, 0);

    if (length > 50) {
      output = braces[0] +
               (base === '' ? '' : base + '\n ') +
               ' ' +
               output.join(',\n  ') +
               ' ' +
               braces[1];
    } else {
      output = braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
    }

    return output;
  }
  return format(obj, (typeof depth === 'undefined' ? 2 : depth));
};

function isArray(ar) {
  return Array.isArray(ar);
}
function isRegExp(re) {
  var s = '' + re;
  return re instanceof RegExp || // easy case
         // duck-type for context-switching evalcx case
         //typeof(re) === 'function' &&
         //re.constructor.name === 'RegExp' &&
         re &&
         re.compile &&
         re.test &&
         re.exec &&
         s.match(/^\/.*\/[gim]{0,3}$/);
}
function isDate(d) {
  if (d && d.getUTCMinutes) return true;
}

if (window.attachEvent && !window.addEventListener) {
  console._log = console.log;
  console.log = function() {
    var args = Array.prototype.slice.call(arguments);
    args = args.map(function(s) { return inspect(s); });
    if (console._log.apply) {
      return console._log.apply(console, args);
    } else {
      return console._log(args.join(' '));
    }
  };
}
})();